"""
    Bamboo Flexibility API

     This API provides access to flexibility assets managed by Bamboo Energy: - Create and list flexibility sites & assets - Obtain activations for specific assets - Post and get measurements for specific assets   # noqa: E501

    The version of the OpenAPI document: 1.8.1
    Contact: development@bambooenergy.tech
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bambooapi_client.api_client import ApiClient, Endpoint as _Endpoint
from bambooapi_client.model_utils import (  # noqa: F401
    check_allowed_values,
    check_validations,
    date,
    datetime,
    file_type,
    none_type,
    validate_and_convert_types
)
from bambooapi_client.model.activation_state import ActivationState
from bambooapi_client.model.baseline_model import BaselineModel
from bambooapi_client.model.device_type_measurements_summary import DeviceTypeMeasurementsSummary
from bambooapi_client.model.flexibility_model import FlexibilityModel
from bambooapi_client.model.http400_bad_request import HTTP400BadRequest
from bambooapi_client.model.http401_unauthorized import HTTP401Unauthorized
from bambooapi_client.model.http403_forbidden import HTTP403Forbidden
from bambooapi_client.model.http404_not_found import HTTP404NotFound
from bambooapi_client.model.http405_method_not_allowed import HTTP405MethodNotAllowed
from bambooapi_client.model.http_validation_error import HTTPValidationError
from bambooapi_client.model.site import Site
from bambooapi_client.model.site_create import SiteCreate
from bambooapi_client.model.site_data_point import SiteDataPoint
from bambooapi_client.model.site_list_item import SiteListItem
from bambooapi_client.model.site_update import SiteUpdate
from bambooapi_client.model.thermal_zone import ThermalZone
from bambooapi_client.model.thermal_zone_setpoints import ThermalZoneSetpoints


class SitesApi(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client
        self.create_site_endpoint = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites',
                'operation_id': 'create_site',
                'http_method': 'POST',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_create',
                ],
                'required': [
                    'site_create',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_create':
                        (SiteCreate,),
                },
                'attribute_map': {
                },
                'location_map': {
                    'site_create': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.delete_site_endpoint = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'delete_site',
                'http_method': 'DELETE',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.get_site_id_by_name_endpoint = _Endpoint(
            settings={
                'response_type': (int,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/id/{site_name}',
                'operation_id': 'get_site_id_by_name',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_name',
                ],
                'required': [
                    'site_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_name':
                        (str,),
                },
                'attribute_map': {
                    'site_name': 'site_name',
                },
                'location_map': {
                    'site_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.insert_device_baseline_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/forecasts/baseline',
                'operation_id': 'insert_device_baseline_forecasts',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'site_data_point': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.insert_device_flexibility_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/forecasts/flexibility',
                'operation_id': 'insert_device_flexibility_forecasts',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                    'horizon',
                    'ramping',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'ramping':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                    'ramping': 'ramping',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'site_data_point': 'body',
                    'horizon': 'query',
                    'ramping': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.insert_device_measurements_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/measurements',
                'operation_id': 'insert_device_measurements',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'site_data_point': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.insert_thermal_zone_flexibility_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/forecasts/flexibility',
                'operation_id': 'insert_thermal_zone_flexibility_forecasts',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'site_data_point',
                    'horizon',
                    'ramping',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                    'site_data_point',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'site_data_point':
                        ([SiteDataPoint],),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'ramping':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                    'ramping': 'ramping',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'site_data_point': 'body',
                    'horizon': 'query',
                    'ramping': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.list_devices_endpoint = _Endpoint(
            settings={
                'response_type': (bool, date, datetime, dict, float, int, list, str, none_type,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices',
                'operation_id': 'list_devices',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_type',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                    'device_type',
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                    ('device_type',): {

                        "METERS": "meters",
                        "SHIFTABLE_LOADS": "shiftable_loads",
                        "BATTERIES": "batteries",
                        "PV_SYSTEMS": "pv_systems",
                        "EV_CHARGERS": "ev_chargers",
                        "THERMAL_LOADS": "thermal_loads",
                        "THERMAL_COMFORT_DEVICES": "thermal_comfort_devices"
                    },
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_type':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_type': 'device_type',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_type': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_sites_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteListItem],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites',
                'operation_id': 'list_sites',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                ],
                'required': [],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                ]
            },
            root_map={
                'validations': {
                },
                'allowed_values': {
                },
                'openapi_types': {
                },
                'attribute_map': {
                },
                'location_map': {
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.list_thermal_zones_endpoint = _Endpoint(
            settings={
                'response_type': ([ThermalZone],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones',
                'operation_id': 'list_thermal_zones',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_baseline_model_endpoint = _Endpoint(
            settings={
                'response_type': (BaselineModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/models/baseline',
                'operation_id': 'read_baseline_model',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_endpoint = _Endpoint(
            settings={
                'response_type': (bool, date, datetime, dict, float, int, list, str, none_type,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}',
                'operation_id': 'read_device',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_activations_endpoint = _Endpoint(
            settings={
                'response_type': (ActivationState,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/activations',
                'operation_id': 'read_device_activations',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'period_start',
                    'period_stop',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'period_start':
                        (datetime,),
                    'period_stop':
                        (datetime,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'period_start': 'query',
                    'period_stop': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_baseline_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/forecasts/baseline',
                'operation_id': 'read_device_baseline_forecasts',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'horizon',
                    'period',
                    'period_start',
                    'period_stop',
                    'frequency',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                    'frequency':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                    'frequency': 'frequency',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'horizon': 'query',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                    'frequency': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_flexibility_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/forecasts/flexibility',
                'operation_id': 'read_device_flexibility_forecasts',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'horizon',
                    'ramping',
                    'period',
                    'period_start',
                    'period_stop',
                    'frequency',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'ramping':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                    'frequency':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                    'ramping': 'ramping',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                    'frequency': 'frequency',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'horizon': 'query',
                    'ramping': 'query',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                    'frequency': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_measurements_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/measurements',
                'operation_id': 'read_device_measurements',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'period',
                    'period_start',
                    'period_stop',
                    'frequency',
                ],
                'required': [
                    'site_id',
                    'device_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'period':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                    'frequency':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                    'frequency': 'frequency',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                    'frequency': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_device_type_measurements_summary_endpoint = _Endpoint(
            settings={
                'response_type': (DeviceTypeMeasurementsSummary,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_type}/measurements/summary',
                'operation_id': 'read_device_type_measurements_summary',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_type',
                    'start_date',
                    'end_date',
                ],
                'required': [
                    'site_id',
                    'device_type',
                    'start_date',
                    'end_date',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_type',
                ]
            },
            root_map={
                'validations': {
                    ('device_type',): {
                        'max_length': 20,
                        'min_length': 1,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_type':
                        (str,),
                    'start_date':
                        (datetime,),
                    'end_date':
                        (datetime,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_type': 'device_type',
                    'start_date': 'start_date',
                    'end_date': 'end_date',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_type': 'path',
                    'start_date': 'query',
                    'end_date': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_flexibility_model_endpoint = _Endpoint(
            settings={
                'response_type': (FlexibilityModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/models/flexibility',
                'operation_id': 'read_flexibility_model',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_site_endpoint = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'read_site',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                ],
                'required': [
                    'site_id',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_thermal_zone_endpoint = _Endpoint(
            settings={
                'response_type': (ThermalZone,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}',
                'operation_id': 'read_thermal_zone',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_thermal_zone_flexibility_forecasts_endpoint = _Endpoint(
            settings={
                'response_type': ([SiteDataPoint],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/forecasts/flexibility',
                'operation_id': 'read_thermal_zone_flexibility_forecasts',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'horizon',
                    'ramping',
                    'period',
                    'period_start',
                    'period_stop',
                    'frequency',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'ramping':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                    'period_start':
                        (str,),
                    'period_stop':
                        (str,),
                    'frequency':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                    'ramping': 'ramping',
                    'period': 'period',
                    'period_start': 'period_start',
                    'period_stop': 'period_stop',
                    'frequency': 'frequency',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'horizon': 'query',
                    'ramping': 'query',
                    'period': 'query',
                    'period_start': 'query',
                    'period_stop': 'query',
                    'frequency': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.read_thermal_zone_setpoints_endpoint = _Endpoint(
            settings={
                'response_type': (ThermalZoneSetpoints,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/setpoints',
                'operation_id': 'read_thermal_zone_setpoints',
                'http_method': 'GET',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [],
            },
            api_client=api_client
        )
        self.update_baseline_model_endpoint = _Endpoint(
            settings={
                'response_type': (BaselineModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/models/baseline',
                'operation_id': 'update_baseline_model',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'baseline_model',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'baseline_model',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'baseline_model':
                        (BaselineModel,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'baseline_model': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.update_device_activations_endpoint = _Endpoint(
            settings={
                'response_type': ([ActivationState],),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/devices/{device_name}/activations',
                'operation_id': 'update_device_activations',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'device_name',
                    'activation_state',
                ],
                'required': [
                    'site_id',
                    'device_name',
                    'activation_state',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'device_name',
                ]
            },
            root_map={
                'validations': {
                    ('device_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'device_name':
                        (str,),
                    'activation_state':
                        ([ActivationState],),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'device_name': 'device_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'device_name': 'path',
                    'activation_state': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.update_flexibility_model_endpoint = _Endpoint(
            settings={
                'response_type': (FlexibilityModel,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/models/flexibility',
                'operation_id': 'update_flexibility_model',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'flexibility_model',
                    'horizon',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                    'flexibility_model',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'flexibility_model':
                        (FlexibilityModel,),
                    'horizon':
                        (bool, date, datetime, dict, float, int, list, str, none_type,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                    'horizon': 'horizon',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'flexibility_model': 'body',
                    'horizon': 'query',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.update_site_endpoint = _Endpoint(
            settings={
                'response_type': (Site,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}',
                'operation_id': 'update_site',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'site_update',
                ],
                'required': [
                    'site_id',
                    'site_update',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'site_update':
                        (SiteUpdate,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                },
                'location_map': {
                    'site_id': 'path',
                    'site_update': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )
        self.update_thermal_zone_setpoints_endpoint = _Endpoint(
            settings={
                'response_type': (ThermalZoneSetpoints,),
                'auth': [
                    'BearerAuth'
                ],
                'endpoint_path': '/sites/{site_id}/thermalZones/{zone_name}/setpoints',
                'operation_id': 'update_thermal_zone_setpoints',
                'http_method': 'PUT',
                'servers': None,
            },
            params_map={
                'all': [
                    'site_id',
                    'zone_name',
                    'thermal_zone_setpoints',
                ],
                'required': [
                    'site_id',
                    'zone_name',
                    'thermal_zone_setpoints',
                ],
                'nullable': [
                ],
                'enum': [
                ],
                'validation': [
                    'site_id',
                    'zone_name',
                ]
            },
            root_map={
                'validations': {
                    ('site_id',): {

                        'inclusive_maximum': 99999,
                        'inclusive_minimum': 10000,
                    },
                    ('zone_name',): {

                        'min_length': 2,
                    },
                },
                'allowed_values': {
                },
                'openapi_types': {
                    'site_id':
                        (int,),
                    'zone_name':
                        (str,),
                    'thermal_zone_setpoints':
                        (ThermalZoneSetpoints,),
                },
                'attribute_map': {
                    'site_id': 'site_id',
                    'zone_name': 'zone_name',
                },
                'location_map': {
                    'site_id': 'path',
                    'zone_name': 'path',
                    'thermal_zone_setpoints': 'body',
                },
                'collection_format_map': {
                }
            },
            headers_map={
                'accept': [
                    'application/json'
                ],
                'content_type': [
                    'application/json'
                ]
            },
            api_client=api_client
        )

    def create_site(
        self,
        site_create,
        **kwargs
    ):
        """Create a Site  # noqa: E501

        Create a Site with all the information:  - **site_name**: each site must have a name - **client_id**: each site must be associated with a client - **prosumer_id**: each site must be associated with a prosumer - **weather_id**: each site must be associated with a weather station - **tariff_id**: each site must be associated with an electricity tariff - **energy_injection**: If True, energy can be injected into the grid - **location**: a site can optionally have a location - **country**: a site can optionally have a country - **country_code**: a site can optionally have an ISO 3166 country code - **timezone**: a site can optionally have a time zone - **latitude**: a site can optionally have a latitude - **longitude**: a site can optionally have a longitude - **elevation**: a site can optionally have an elevation - **microgrid**: a site must have a microgrid JSON describing devices and sensors  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.create_site(site_create, async_req=True)
        >>> result = thread.get()

        Args:
            site_create (SiteCreate):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Site
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_create'] = \
            site_create
        return self.create_site_endpoint.call_with_http_info(**kwargs)

    def delete_site(
        self,
        site_id,
        **kwargs
    ):
        """Delete a Site  # noqa: E501

        Delete a Site.  **WARNING!: Site deletion is PERMANENT!** (no way to recover deleted site)  **WARNING!: Deleting a Site does not delete the associated measurements,  forecasts or tariffs!**  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.delete_site(site_id, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Site
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        return self.delete_site_endpoint.call_with_http_info(**kwargs)

    def get_site_id_by_name(
        self,
        site_name,
        **kwargs
    ):
        """Retrieve Site ID given a Site Name  # noqa: E501

        Retrieve Site ID given a Site Name.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.get_site_id_by_name(site_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_name (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            int
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_name'] = \
            site_name
        return self.get_site_id_by_name_endpoint.call_with_http_info(**kwargs)

    def insert_device_baseline_forecasts(
        self,
        site_id,
        device_name,
        site_data_point,
        **kwargs
    ):
        """Insert/update baseline forecasts for selected device  # noqa: E501

        Insert/update baseline forecasts for selected device.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.insert_device_baseline_forecasts(site_id, device_name, site_data_point, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):
            site_data_point ([SiteDataPoint]):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        kwargs['site_data_point'] = \
            site_data_point
        return self.insert_device_baseline_forecasts_endpoint.call_with_http_info(**kwargs)

    def insert_device_flexibility_forecasts(
        self,
        site_id,
        device_name,
        site_data_point,
        **kwargs
    ):
        """Insert/update flexibility forecasts for selected device  # noqa: E501

        Insert/update flexibility forecasts for selected device.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.insert_device_flexibility_forecasts(site_id, device_name, site_data_point, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):
            site_data_point ([SiteDataPoint]):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            ramping (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        kwargs['site_data_point'] = \
            site_data_point
        return self.insert_device_flexibility_forecasts_endpoint.call_with_http_info(**kwargs)

    def insert_device_measurements(
        self,
        site_id,
        device_name,
        site_data_point,
        **kwargs
    ):
        """Insert/update measurements for selected device  # noqa: E501

        Insert/update measurements for selected device.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.insert_device_measurements(site_id, device_name, site_data_point, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):
            site_data_point ([SiteDataPoint]):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        kwargs['site_data_point'] = \
            site_data_point
        return self.insert_device_measurements_endpoint.call_with_http_info(**kwargs)

    def insert_thermal_zone_flexibility_forecasts(
        self,
        site_id,
        zone_name,
        site_data_point,
        **kwargs
    ):
        """Insert/update flexibility forecasts for selected thermal zone  # noqa: E501

        Insert/update flexibility forecasts for selected thermal zone.  - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.insert_thermal_zone_flexibility_forecasts(site_id, zone_name, site_data_point, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):
            site_data_point ([SiteDataPoint]):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            ramping (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        kwargs['site_data_point'] = \
            site_data_point
        return self.insert_thermal_zone_flexibility_forecasts_endpoint.call_with_http_info(**kwargs)

    def list_devices(
        self,
        site_id,
        **kwargs
    ):
        """List all devices for a given Site  # noqa: E501

        List all devices for a given Site.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_devices(site_id, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):

        Keyword Args:
            device_type (str): [optional] if omitted the server will use the default value of "meters"
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            bool, date, datetime, dict, float, int, list, str, none_type
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        return self.list_devices_endpoint.call_with_http_info(**kwargs)

    def list_sites(
        self,
        **kwargs
    ):
        """List all Sites  # noqa: E501

        List all Sites.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_sites(async_req=True)
        >>> result = thread.get()


        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteListItem]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        return self.list_sites_endpoint.call_with_http_info(**kwargs)

    def list_thermal_zones(
        self,
        site_id,
        **kwargs
    ):
        """List all thermal zones for a given Site  # noqa: E501

        List all thermal zones for a given Site.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.list_thermal_zones(site_id, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [ThermalZone]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        return self.list_thermal_zones_endpoint.call_with_http_info(**kwargs)

    def read_baseline_model(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return baseline model parameters for selected device  # noqa: E501

        Return baseline model parameters for selected device.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_baseline_model(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BaselineModel
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_baseline_model_endpoint.call_with_http_info(**kwargs)

    def read_device(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return description of selected device  # noqa: E501

        Return description of selected device.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            bool, date, datetime, dict, float, int, list, str, none_type
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_device_endpoint.call_with_http_info(**kwargs)

    def read_device_activations(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return current activation state for selected device  # noqa: E501

        Return the latest activation state for selected device.  The activation state maximum lifetime is 15 minutes by default. Thus, if there are no activations in the previous 15 minutes, the endpoint returns a (probably meaningless) default placeholder value.  Returns HTTP400 if the device is not controllable.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device_activations(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            period_start (datetime): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". If not provided, the default value is 15 minutes before `period_stop`.. [optional]
            period_stop (datetime): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". If not provided, the default value is now.. [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ActivationState
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_device_activations_endpoint.call_with_http_info(**kwargs)

    def read_device_baseline_forecasts(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return baseline forecasts for selected device  # noqa: E501

        Return baseline forecasts for selected device.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device_baseline_forecasts(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period_start (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            period_stop (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            frequency (bool, date, datetime, dict, float, int, list, str, none_type): Aggregate measurements to this frequency. The measurements will include data for whole periods.  For example, if _period_start_ = '2021-05-01T10:23:00Z', _period_stop_ = '2021-05-01T10:49:00Z' and _frequency_ = 'quarter', the backend queries data from '2021-05-01T10:15:00Z' to '2021-05-01T11:00:00Z' (not included) and resamples it every 15 minutes.  . [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_device_baseline_forecasts_endpoint.call_with_http_info(**kwargs)

    def read_device_flexibility_forecasts(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return flexibility forecasts for selected device  # noqa: E501

        Return flexibility forecasts for selected device.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device_flexibility_forecasts(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            ramping (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period_start (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            period_stop (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            frequency (bool, date, datetime, dict, float, int, list, str, none_type): Aggregate measurements to this frequency. The measurements will include data for whole periods.  For example, if _period_start_ = '2021-05-01T10:23:00Z', _period_stop_ = '2021-05-01T10:49:00Z' and _frequency_ = 'quarter', the backend queries data from '2021-05-01T10:15:00Z' to '2021-05-01T11:00:00Z' (not included) and resamples it every 15 minutes.  . [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_device_flexibility_forecasts_endpoint.call_with_http_info(**kwargs)

    def read_device_measurements(
        self,
        site_id,
        device_name,
        **kwargs
    ):
        """Return measurements for selected device  # noqa: E501

        Return measurements for selected device.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device_measurements(site_id, device_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):

        Keyword Args:
            period (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period_start (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            period_stop (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            frequency (bool, date, datetime, dict, float, int, list, str, none_type): Aggregate measurements to this frequency. The measurements will include data for whole periods.  For example, if _period_start_ = '2021-05-01T10:23:00Z', _period_stop_ = '2021-05-01T10:49:00Z' and _frequency_ = 'quarter', the backend queries data from '2021-05-01T10:15:00Z' to '2021-05-01T11:00:00Z' (not included) and resamples it every 15 minutes.  . [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        return self.read_device_measurements_endpoint.call_with_http_info(**kwargs)

    def read_device_type_measurements_summary(
        self,
        site_id,
        device_type,
        start_date,
        end_date,
        **kwargs
    ):
        """Get summary statistics of a site by device type  # noqa: E501

        Get total consumed or generated energy of a site by device type.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_device_type_measurements_summary(site_id, device_type, start_date, end_date, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_type (str):
            start_date (datetime): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\"
            end_date (datetime): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\"

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            DeviceTypeMeasurementsSummary
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_type'] = \
            device_type
        kwargs['start_date'] = \
            start_date
        kwargs['end_date'] = \
            end_date
        return self.read_device_type_measurements_summary_endpoint.call_with_http_info(**kwargs)

    def read_flexibility_model(
        self,
        site_id,
        zone_name,
        **kwargs
    ):
        """Return flexibility model parameters for selected thermal zone  # noqa: E501

        Return flexibility model parameters for selected thermal zone.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_flexibility_model(site_id, zone_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            FlexibilityModel
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        return self.read_flexibility_model_endpoint.call_with_http_info(**kwargs)

    def read_site(
        self,
        site_id,
        **kwargs
    ):
        """Info about a specific Site  # noqa: E501

        Info about a specific Site.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_site(site_id, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Site
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        return self.read_site_endpoint.call_with_http_info(**kwargs)

    def read_thermal_zone(
        self,
        site_id,
        zone_name,
        **kwargs
    ):
        """Return description of selected thermal zone  # noqa: E501

        Return description of selected thermal zone.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_thermal_zone(site_id, zone_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ThermalZone
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        return self.read_thermal_zone_endpoint.call_with_http_info(**kwargs)

    def read_thermal_zone_flexibility_forecasts(
        self,
        site_id,
        zone_name,
        **kwargs
    ):
        """Return flexibility forecasts for selected thermal zone  # noqa: E501

        Return flexibility forecasts for selected thermal zone.  - **Timestamps are ordered from oldest to newest** - **Data is returned with the same sign convention as when pushed** (not transformation applied)  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_thermal_zone_flexibility_forecasts(site_id, zone_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            ramping (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            period_start (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            period_stop (str): A timestamp in RFC3339 format, in UTC timezone (\"YYYY-MM-DDT00:00:00Z\"). Make sure to specify the timezone either with \"Z\" or \"+00:00\". [optional]
            frequency (bool, date, datetime, dict, float, int, list, str, none_type): Aggregate measurements to this frequency. The measurements will include data for whole periods.  For example, if _period_start_ = '2021-05-01T10:23:00Z', _period_stop_ = '2021-05-01T10:49:00Z' and _frequency_ = 'quarter', the backend queries data from '2021-05-01T10:15:00Z' to '2021-05-01T11:00:00Z' (not included) and resamples it every 15 minutes.  . [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [SiteDataPoint]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        return self.read_thermal_zone_flexibility_forecasts_endpoint.call_with_http_info(**kwargs)

    def read_thermal_zone_setpoints(
        self,
        site_id,
        zone_name,
        **kwargs
    ):
        """Return setpoint parameters for selected thermal zone  # noqa: E501

        Return setpoint parameters for selected thermal zone.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.read_thermal_zone_setpoints(site_id, zone_name, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ThermalZoneSetpoints
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        return self.read_thermal_zone_setpoints_endpoint.call_with_http_info(**kwargs)

    def update_baseline_model(
        self,
        site_id,
        device_name,
        baseline_model,
        **kwargs
    ):
        """Set/update baseline model parameters for selected device  # noqa: E501

        Set/update baseline model parameters for selected device.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_baseline_model(site_id, device_name, baseline_model, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):
            baseline_model (BaselineModel):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            BaselineModel
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        kwargs['baseline_model'] = \
            baseline_model
        return self.update_baseline_model_endpoint.call_with_http_info(**kwargs)

    def update_device_activations(
        self,
        site_id,
        device_name,
        activation_state,
        **kwargs
    ):
        """Set/update activation states for the selected device  # noqa: E501

        Set/Update activation state for selected device.  - **The activation state maximum lifetime is 15 minutes by default**. Activation states can be overridden by other Activation states. - **Timestamps don't need to be pushed in any particular order** - **Data points will be stored exactly as pushed** (no transformation applied)  Returns HTTP400 if the device is not controllable.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_device_activations(site_id, device_name, activation_state, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            device_name (str):
            activation_state ([ActivationState]):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            [ActivationState]
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['device_name'] = \
            device_name
        kwargs['activation_state'] = \
            activation_state
        return self.update_device_activations_endpoint.call_with_http_info(**kwargs)

    def update_flexibility_model(
        self,
        site_id,
        zone_name,
        flexibility_model,
        **kwargs
    ):
        """Set/update flexibility model parameters for selected thermal zone  # noqa: E501

        Set/update flexibility model parameters for selected thermal zone.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_flexibility_model(site_id, zone_name, flexibility_model, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):
            flexibility_model (FlexibilityModel):

        Keyword Args:
            horizon (bool, date, datetime, dict, float, int, list, str, none_type): [optional]
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            FlexibilityModel
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        kwargs['flexibility_model'] = \
            flexibility_model
        return self.update_flexibility_model_endpoint.call_with_http_info(**kwargs)

    def update_site(
        self,
        site_id,
        site_update,
        **kwargs
    ):
        """Update an existing Site  # noqa: E501

        Update information about a Site.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_site(site_id, site_update, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            site_update (SiteUpdate):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            Site
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['site_update'] = \
            site_update
        return self.update_site_endpoint.call_with_http_info(**kwargs)

    def update_thermal_zone_setpoints(
        self,
        site_id,
        zone_name,
        thermal_zone_setpoints,
        **kwargs
    ):
        """Set/Update setpoint parameters for selected thermal zone  # noqa: E501

        Set/Update setpoint parameters for selected thermal zone.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.update_thermal_zone_setpoints(site_id, zone_name, thermal_zone_setpoints, async_req=True)
        >>> result = thread.get()

        Args:
            site_id (int):
            zone_name (str):
            thermal_zone_setpoints (ThermalZoneSetpoints):

        Keyword Args:
            _return_http_data_only (bool): response data without head status
                code and headers. Default is True.
            _preload_content (bool): if False, the urllib3.HTTPResponse object
                will be returned without reading/decoding response data.
                Default is True.
            _request_timeout (int/float/tuple): timeout setting for this request. If
                one number provided, it will be total request timeout. It can also
                be a pair (tuple) of (connection, read) timeouts.
                Default is None.
            _check_input_type (bool): specifies if type checking
                should be done one the data sent to the server.
                Default is True.
            _check_return_type (bool): specifies if type checking
                should be done one the data received from the server.
                Default is True.
            _spec_property_naming (bool): True if the variable names in the input data
                are serialized names, as specified in the OpenAPI document.
                False if the variable names in the input data
                are pythonic names, e.g. snake case (default)
            _content_type (str/None): force body content-type.
                Default is None and content-type will be predicted by allowed
                content-types and body.
            _host_index (int/None): specifies the index of the server
                that we want to use.
                Default is read from the configuration.
            async_req (bool): execute request asynchronously

        Returns:
            ThermalZoneSetpoints
                If the method is called asynchronously, returns the request
                thread.
        """
        kwargs['async_req'] = kwargs.get(
            'async_req', False
        )
        kwargs['_return_http_data_only'] = kwargs.get(
            '_return_http_data_only', True
        )
        kwargs['_preload_content'] = kwargs.get(
            '_preload_content', True
        )
        kwargs['_request_timeout'] = kwargs.get(
            '_request_timeout', None
        )
        kwargs['_check_input_type'] = kwargs.get(
            '_check_input_type', True
        )
        kwargs['_check_return_type'] = kwargs.get(
            '_check_return_type', True
        )
        kwargs['_spec_property_naming'] = kwargs.get(
            '_spec_property_naming', False
        )
        kwargs['_content_type'] = kwargs.get(
            '_content_type')
        kwargs['_host_index'] = kwargs.get('_host_index')
        kwargs['site_id'] = \
            site_id
        kwargs['zone_name'] = \
            zone_name
        kwargs['thermal_zone_setpoints'] = \
            thermal_zone_setpoints
        return self.update_thermal_zone_setpoints_endpoint.call_with_http_info(**kwargs)

