"""
    Bamboo Flexibility API

     This API provides access to flexibility assets managed by Bamboo Energy: - Create and list flexibility sites & assets - Obtain activations for specific assets - Post and get measurements for specific assets   # noqa: E501

    The version of the OpenAPI document: 1.8.1
    Contact: development@bambooenergy.tech
    Generated by: https://openapi-generator.tech
"""


import re  # noqa: F401
import sys  # noqa: F401

from bambooapi_client.model_utils import (  # noqa: F401
    ApiTypeError,
    ModelComposed,
    ModelNormal,
    ModelSimple,
    cached_property,
    change_keys_js_to_python,
    convert_js_args_to_python_args,
    date,
    datetime,
    file_type,
    none_type,
    validate_get_composed_info,
    OpenApiModel
)
from bambooapi_client.exceptions import ApiAttributeError


def lazy_import():
    from bambooapi_client.model.battery import Battery
    from bambooapi_client.model.ev_charger import EVCharger
    from bambooapi_client.model.load import Load
    from bambooapi_client.model.meter import Meter
    from bambooapi_client.model.pv_system import PVSystem
    from bambooapi_client.model.shiftable_load import ShiftableLoad
    from bambooapi_client.model.thermal_comfort_device import ThermalComfortDevice
    from bambooapi_client.model.thermal_load import ThermalLoad
    globals()['Battery'] = Battery
    globals()['EVCharger'] = EVCharger
    globals()['Load'] = Load
    globals()['Meter'] = Meter
    globals()['PVSystem'] = PVSystem
    globals()['ShiftableLoad'] = ShiftableLoad
    globals()['ThermalComfortDevice'] = ThermalComfortDevice
    globals()['ThermalLoad'] = ThermalLoad


class Devices(ModelNormal):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Attributes:
      allowed_values (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          with a capitalized key describing the allowed value and an allowed
          value. These dicts store the allowed enum values.
      attribute_map (dict): The key is attribute name
          and the value is json key in definition.
      discriminator_value_class_map (dict): A dict to go from the discriminator
          variable value to the discriminator class name.
      validations (dict): The key is the tuple path to the attribute
          and the for var_name this is (var_name,). The value is a dict
          that stores validations for max_length, min_length, max_items,
          min_items, exclusive_maximum, inclusive_maximum, exclusive_minimum,
          inclusive_minimum, and regex.
      additional_properties_type (tuple): A tuple of classes accepted
          as additional properties values.
    """

    allowed_values = {
    }

    validations = {
    }

    @cached_property
    def additional_properties_type():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded
        """
        lazy_import()
        return (bool, date, datetime, dict, float, int, list, str, none_type,)  # noqa: E501

    _nullable = False

    @cached_property
    def openapi_types():
        """
        This must be a method because a model may have properties that are
        of type self, this must run after the class is loaded

        Returns
            openapi_types (dict): The key is attribute name
                and the value is attribute type.
        """
        lazy_import()
        return {
            'meters': ([Meter],),  # noqa: E501
            'loads': ([Load],),  # noqa: E501
            'shiftable_loads': ([ShiftableLoad],),  # noqa: E501
            'pv_systems': ([PVSystem],),  # noqa: E501
            'ev_chargers': ([EVCharger],),  # noqa: E501
            'batteries': ([Battery],),  # noqa: E501
            'thermal_loads': ([ThermalLoad],),  # noqa: E501
            'thermal_comfort_devices': ([ThermalComfortDevice],),  # noqa: E501
        }

    @cached_property
    def discriminator():
        return None


    attribute_map = {
        'meters': 'meters',  # noqa: E501
        'loads': 'loads',  # noqa: E501
        'shiftable_loads': 'shiftable_loads',  # noqa: E501
        'pv_systems': 'pv_systems',  # noqa: E501
        'ev_chargers': 'ev_chargers',  # noqa: E501
        'batteries': 'batteries',  # noqa: E501
        'thermal_loads': 'thermal_loads',  # noqa: E501
        'thermal_comfort_devices': 'thermal_comfort_devices',  # noqa: E501
    }

    read_only_vars = {
    }

    _composed_schemas = {}

    @classmethod
    @convert_js_args_to_python_args
    def _from_openapi_data(cls, meters, loads, shiftable_loads, pv_systems, ev_chargers, batteries, thermal_loads, thermal_comfort_devices, *args, **kwargs):  # noqa: E501
        """Devices - a model defined in OpenAPI

        Args:
            meters ([Meter]):
            loads ([Load]):
            shiftable_loads ([ShiftableLoad]):
            pv_systems ([PVSystem]):
            ev_chargers ([EVCharger]):
            batteries ([Battery]):
            thermal_loads ([ThermalLoad]):
            thermal_comfort_devices ([ThermalComfortDevice]):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        self = super(OpenApiModel, cls).__new__(cls)

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.meters = meters
        self.loads = loads
        self.shiftable_loads = shiftable_loads
        self.pv_systems = pv_systems
        self.ev_chargers = ev_chargers
        self.batteries = batteries
        self.thermal_loads = thermal_loads
        self.thermal_comfort_devices = thermal_comfort_devices
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
        return self

    required_properties = set([
        '_data_store',
        '_check_type',
        '_spec_property_naming',
        '_path_to_item',
        '_configuration',
        '_visited_composed_classes',
    ])

    @convert_js_args_to_python_args
    def __init__(self, meters, loads, shiftable_loads, pv_systems, ev_chargers, batteries, thermal_loads, thermal_comfort_devices, *args, **kwargs):  # noqa: E501
        """Devices - a model defined in OpenAPI

        Args:
            meters ([Meter]):
            loads ([Load]):
            shiftable_loads ([ShiftableLoad]):
            pv_systems ([PVSystem]):
            ev_chargers ([EVCharger]):
            batteries ([Battery]):
            thermal_loads ([ThermalLoad]):
            thermal_comfort_devices ([ThermalComfortDevice]):

        Keyword Args:
            _check_type (bool): if True, values for parameters in openapi_types
                                will be type checked and a TypeError will be
                                raised if the wrong type is input.
                                Defaults to True
            _path_to_item (tuple/list): This is a list of keys or values to
                                drill down to the model in received_data
                                when deserializing a response
            _spec_property_naming (bool): True if the variable names in the input data
                                are serialized names, as specified in the OpenAPI document.
                                False if the variable names in the input data
                                are pythonic names, e.g. snake case (default)
            _configuration (Configuration): the instance to use when
                                deserializing a file_type parameter.
                                If passed, type conversion is attempted
                                If omitted no type conversion is done.
            _visited_composed_classes (tuple): This stores a tuple of
                                classes that we have traveled through so that
                                if we see that class again we will not use its
                                discriminator again.
                                When traveling through a discriminator, the
                                composed schema that is
                                is traveled through is added to this set.
                                For example if Animal has a discriminator
                                petType and we pass in "Dog", and the class Dog
                                allOf includes Animal, we move through Animal
                                once using the discriminator, and pick Dog.
                                Then in Dog, we will make an instance of the
                                Animal class but this time we won't travel
                                through its discriminator because we passed in
                                _visited_composed_classes = (Animal,)
        """

        _check_type = kwargs.pop('_check_type', True)
        _spec_property_naming = kwargs.pop('_spec_property_naming', False)
        _path_to_item = kwargs.pop('_path_to_item', ())
        _configuration = kwargs.pop('_configuration', None)
        _visited_composed_classes = kwargs.pop('_visited_composed_classes', ())

        if args:
            raise ApiTypeError(
                "Invalid positional arguments=%s passed to %s. Remove those invalid positional arguments." % (
                    args,
                    self.__class__.__name__,
                ),
                path_to_item=_path_to_item,
                valid_classes=(self.__class__,),
            )

        self._data_store = {}
        self._check_type = _check_type
        self._spec_property_naming = _spec_property_naming
        self._path_to_item = _path_to_item
        self._configuration = _configuration
        self._visited_composed_classes = _visited_composed_classes + (self.__class__,)

        self.meters = meters
        self.loads = loads
        self.shiftable_loads = shiftable_loads
        self.pv_systems = pv_systems
        self.ev_chargers = ev_chargers
        self.batteries = batteries
        self.thermal_loads = thermal_loads
        self.thermal_comfort_devices = thermal_comfort_devices
        for var_name, var_value in kwargs.items():
            if var_name not in self.attribute_map and \
                        self._configuration is not None and \
                        self._configuration.discard_unknown_keys and \
                        self.additional_properties_type is None:
                # discard variable.
                continue
            setattr(self, var_name, var_value)
            if var_name in self.read_only_vars:
                raise ApiAttributeError(f"`{var_name}` is a read-only attribute. Use `from_openapi_data` to instantiate "
                                     f"class with read only attributes.")
